
/**
 * JMichelle (Java Midori Shell)
 * Copyright (C) 2000 Midori IGA 
 *   (http://www01.u-page.so-net.ne.jp/db3/midori/midosoft.html)
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

package jp.ne.nifty.iga.midori.shell.io;

import jp.ne.nifty.iga.midori.shell.dir.*;
import jp.ne.nifty.iga.midori.shell.io.*;
import jp.ne.nifty.iga.midori.shell.util.*;
import java.io.*;
import java.text.Collator;
import java.util.*;

/**
 * JMichelle (Java Midori Shell) : 
 */
public class MdShellDirLongListFormatter
	implements MdShellDisplayFormatterInterface
{
	public int iTotalFileLength=0;
	public int iTotalDirectoryCount=0;
	public int iTotalFileCount=0;

	public String format(Object objArg)
	{
		if(objArg==null)
		{
			return null;
		}

		MdShellDirNodeInterface path=(MdShellDirNodeInterface)objArg;

		StringBuffer strbufWrk=new StringBuffer();
		{
			if(path instanceof MdShellDirDirectoryAbstract)
			{
				//if(isRecursive
				//&& !(isSortByTimeStamp||isSortByFileSize))
				//{
				//	strbufWrk.append("\n");
				//}
				strbufWrk.append("d");
				iTotalDirectoryCount++;
			}
			else
			{
				strbufWrk.append("-");
				iTotalFileCount++;
			}
			iTotalFileLength+=path.getFileLength();

			if(path.canRead())
			{
				strbufWrk.append("r");
			}
			else
			{
				strbufWrk.append("-");
			}

			if(path.canWrite())
			{
				strbufWrk.append("w");
			}
			else
			{
				strbufWrk.append("-");
			}

			if(path instanceof MdShellDirDirectoryAbstract
			|| path.getShortName().toUpperCase().endsWith(".BAT")
			|| path.getShortName().toUpperCase().endsWith(".EXE"))
			{
				// executable...
				strbufWrk.append("x");
			}
			else
			{
				strbufWrk.append("-");
			}

			strbufWrk.append(" ");

			strbufWrk.append(MdShellUtilString.numberToString(path.getFileLength(),12)+" ");
			strbufWrk.append(MdShellUtilString.convertLastModifiedToString(path.getLastModified()));

			strbufWrk.append(" ");

			//strbufWrk.append(path.getName().substring(iBaseLength+1));
			strbufWrk.append(path.getShortName());
		}
		return strbufWrk.toString();
	}
}

